
*************************************************************************************** 
*   PROGRAMA:  PUZZLE CAMBA WIN
*   VERSION:   1.1
*   FECHA:     16 MARZO 2010
*   IDIOMA:    ESPAOL/INGLES/PORTUGUES
*   LENGUAJE:  HARBOUR-MINIGUI 3.0.25
*
*   AUTOR:     CLAUDIO SOTO SILVA
*   PAIS:      URUGUAY
*   E-MAIL:    srvet@adinet.com.uy
*
*   Modified for Hmg by Mustafa Lpez & el Rateret del Culebrn-Xinorlet 2018 
***************************************************************************************


#include "minigui.ch"

#define PROG_NOMBRE  "Contabilidad"
#define ARCH_IDIOMA  'Idioma.cfg'



*#########################################################################################################################
*         VENTANA PRINCIPAL 
*#########################################################################################################################


Function Main


#define PROG_SPANISH    1
#define PROG_ENGLISH    2
#define PROG_VALENCIAN  3

PRIVATE CurDir := GetStartUpFolder()
PRIVATE ID := 0
ID := prog_ini ()

* Establece el idioma / Sets the language / Define o idioma
* ID := PROG_SPANISH
* ID := PROG_ENGLISH
* ID := PROG_VALENCIAN


* MATRICES QUE CONTIENEN EL TEXTO EN ESPAOL/INGLES/VALENCIANO 
* (facilitan las correcciones en el texto y permiten agregar facilmente otros idiomas)
* Traduccion con ayuda de GOOGLE TRADUCTOR


PRIVATE txt_PROG_VER := {"Versin 1.1,Octubre 2018 , Petrer","Version 1.1, October 2018, Peter","Versi 1.1, octubre 2018, Petrer"}

	
PRIVATE txt_MAIN_MENU1 := {{'&Empresas','&Busines','&Empreses'},;                               
                           {'Datos generales de la empresa', 'General information about the company', "Dades generals de l'empresa"},;   
                           {'Crea los Conceptos Contables', 'Create the Accounting Concepts', "Crea els Conceptes Comptables  "},;   
                           {'Crea las cuentas del Plan Contable', 'Create accounts of the Accounting Plan', "Crea els comptes del Pla Comptable"},;   
                           {'Crea los apuntes contables', 'Create accounting notes', "Crea els apunts comptables"},;   
                           {'Salir','Exit',"Eixida"}}
*----------------------------------------------------------------------------------------------------------------------------------------------------------*
                                  
PRIVATE txt_MAIN_MENU2 := {{'&Configuracin','&Configuration','&Configuraci'},;
                           {'Idioma ...','Language ...',"Idioma ..."}}
*----------------------------------------------------------------------------------------------------------------------------------------------------------*
                                   
PRIVATE txt_MAIN_MENU3 := {{'&Info','&Help','&Ajuda'},;
                           {'Programa',  'Program', "Programa"},;
                           {'Autor',     'Author',  "Autor"}}

PRIVATE txt_msginfo1 := {"","",""}

PRIVATE txt_MsgYesNo1 := {{" Esta seguro que desea terminar la partida actual y abandonar el programa ?","Are you sure want to end the game and exit the program ?", "Voc tem certeza que quer terminar o jogo atual e encerrar o programa ?"},;
                          {"Terminar y salir del programa","Finish and exit the program", "Acabar i exir del programa"}} 

PRIVATE txt_cuadricula3  := {"&Aceptar",           "&Ok",               "&Aceptar"}
PRIVATE txt_cuadricula4  := {"&Cancelar",          "&Cancel",           "&Cancelar"}
                                
PRIVATE txt_Win_Title3 := {{"Movimientos: ","Movements: ", "Movimentos: "},;
                           {"Armado: ",     "Completed: ", "Armado: "}}

PRIVATE txt_idioma := {{'Espaol',  'Ingls',  'Valenciano'},;
                       {'Spanish',  'English', 'Valencian'},; 
                       {'Espanyol', 'Angls',  'Valenci'}}
                       
PRIVATE txt_Win_Title4 := {"Establece el idioma ...","Sets the language ...","Estableix l'idioma ..."}
                      

                            
PRIVATE  jugar := .F.
PRIVATE  ancho_ventana := 750
PRIVATE  largo_ventana := 560

	DEFINE WINDOW Ventana_principal ;
		AT 0,0 ;
		WIDTH ancho_ventana HEIGHT largo_ventana ;		
		TITLE PROG_NOMBRE;
		MAIN ;
		ICON nil ; 
		NOSIZE;
		NOMAXIMIZE;
		ON INTERACTIVECLOSE salir_programa ()
        
		DEFINE MAIN MENU 
			POPUP   txt_MAIN_MENU1 [1,ID] 
                             ITEM     txt_MAIN_MENU1 [2,ID]  ACTION   nil  
			    SEPARATOR
			     ITEM     txt_MAIN_MENU1 [3,ID]  ACTION   nil  
			     ITEM     txt_MAIN_MENU1 [4,ID]  ACTION   nil 
			    SEPARATOR
			     ITEM     txt_MAIN_MENU1 [5,ID]  ACTION   nil 
			     SEPARATOR
			     ITEM     txt_MAIN_MENU1 [6,ID]  ACTION salir_programa () 
			END POPUP
			
			POPUP  txt_MAIN_MENU2 [1,ID]			    
			    MENUITEM    txt_MAIN_MENU2 [2,ID]  ACTION cambiar_idioma ()
			END POPUP
						
			POPUP txt_MAIN_MENU3 [1,ID]
			    ITEM txt_MAIN_MENU3 [2,ID]  ACTION MsgInfo (txt_msginfo1 [ID]+ txt_PROG_VER [ID],PROG_NOMBRE)
			    ITEM txt_MAIN_MENU3 [3,ID]	ACTION MsgInfo ("Dr. Claudio Soto"+ space (20) +chr(13)+"srvet@adinet.com.uy"+chr(13)+"Artigas - Uruguay",PROG_NOMBRE) 
			END POPUP
		END MENU
 
        
  		
	END WINDOW


	CENTER WINDOW Ventana_principal		
	ACTIVATE WINDOW Ventana_principal
	

Return Nil



*****************************************************************************
procedure prog_ini
    
     IF FILE (CurDir+"\"+ARCH_IDIOMA)
        Idioma := alltrim(MEMOREAD (CurDir+"\"+ARCH_IDIOMA))
        ID := VAL (Idioma)
     ENDIF
     
     DO CASE
        CASE ID = PROG_SPANISH	
	         SET CODEPAGE TO SPANISH
	         SET LANGUAGE TO SPANISH

        CASE ID = PROG_ENGLISH	
	         SET CODEPAGE TO ENGLISH
	         SET LANGUAGE TO ENGLISH
	    
        CASE ID = PROG_VALENCIAN	

                REQUEST HB_CODEPAGE_FRWIN   // se pone Frances por el tema acentos compatible
                HB_SETCODEPAGE("FRWIN")    
                REQUEST HB_LANG_FR   
                HB_LANGSELECT("FR")  

        OTHERWISE	    
             ID := PROG_SPANISH
             SET CODEPAGE TO SPANISH
             SET LANGUAGE TO SPANISH
     ENDCASE
return (ID)

*******************************************************************************
procedure cambiar_idioma
 
#define ANCHO_AUX 400
#define LARGO_AUX 200
    
    DEFINE WINDOW Ventana_aux;
            AT (Ventana_principal.Height - LARGO_AUX)/2 + Ventana_principal.Row,(Ventana_principal.Width - ANCHO_AUX)/2 + Ventana_principal.Col;
            WIDTH  ANCHO_AUX;
            HEIGHT LARGO_AUX;
            TITLE txt_Win_Title4 [ID];
            MODAL;
            NOSIZE NOSYSMENU 
		
                @ 20 ,100 FRAME Frame_idioma OF Ventana_aux CAPTION "" WIDTH 200 HEIGHT 70
	        @ 50 ,130 COMBOBOX Combobox_idioma OF Ventana_aux;
            ITEMS txt_idioma [ID] VALUE ID
            
            @ 110, 80  BUTTON Boton_Aceptar  OF Ventana_aux CAPTION txt_cuadricula3 [ID] ONCLICK aceptar_idioma ()
            @ 110, 220 BUTTON Boton_Cancelar OF Ventana_aux CAPTION txt_cuadricula4 [ID] ONCLICK {||Ventana_aux.Release}

    END WINDOW
    ACTIVATE WINDOW Ventana_aux
return


procedure aceptar_idioma 

    ID := Ventana_aux.Combobox_idioma.Value
    MEMOWRIT(CurDir+"\"+ARCH_IDIOMA,str(ID))
    
    hWND := GetFormHandle ("Ventana_principal")
 
    SET_MENU_TXT (hWND, 1, txt_MAIN_MENU1 [1,ID])
           SET_SUBMENU_TXT (hWND, 1, 1, txt_MAIN_MENU1 [2,ID])           
           SET_SUBMENU_TXT (hWND, 1, 2, "")                // SEPARATOR              
           SET_SUBMENU_TXT (hWND, 1, 3, txt_MAIN_MENU1 [3,ID])
           SET_SUBMENU_TXT (hWND, 1, 4, txt_MAIN_MENU1 [4,ID])           
           SET_SUBMENU_TXT (hWND, 1, 5, "")                // SEPARATOR
           SET_SUBMENU_TXT (hWND, 1, 6, txt_MAIN_MENU1 [5,ID])           
           SET_SUBMENU_TXT (hWND, 1, 7, "")                // SEPARATOR 
           SET_SUBMENU_TXT (hWND, 1, 8, txt_MAIN_MENU1 [6,ID])
           SET_SUBMENU_TXT (hWND, 1, 9, "")                // SEPARATOR
     
  
    SET_MENU_TXT (hWND, 2, txt_MAIN_MENU2 [1,ID]) 
           SET_SUBMENU_TXT (hWND, 2, 1, txt_MAIN_MENU2 [2,ID])
  
           
    SET_MENU_TXT (hWND, 3, txt_MAIN_MENU3 [1,ID])
        *   SET_SUBMENU_TXT (hWND, 3, 1, txt_MAIN_MENU3 [2,ID])
        *   SET_SUBMENU_TXT (hWND, 3, 2, txt_MAIN_MENU3 [3,ID])
    
    DO CASE
        CASE ID = PROG_SPANISH	
	         SET CODEPAGE TO SPANISH
	         SET LANGUAGE TO SPANISH

        CASE ID = PROG_ENGLISH	
	         SET CODEPAGE TO ENGLISH
	         SET LANGUAGE TO ENGLISH
	    
        CASE ID = PROG_VALENCIAN

                REQUEST HB_CODEPAGE_FRWIN   // se pone Frances por el tema acentos compatible
                HB_SETCODEPAGE("FRWIN")    
                REQUEST HB_LANG_FR   
                HB_LANGSELECT("FR")  

	ENDCASE                  
    
    Ventana_aux.Release
return




*******************************************************************************
procedure salir_programa

     IF jugar = .T.
             IF MsgYesNo (txt_MsgYesNo1 [1,ID],txt_MsgYesNo1 [2,ID], .T.) = .F.
                return .F.
             ENDIF   
     ENDIF
     
     Ventana_principal.Release   
return .T.


*#########################################################################################################################
*   CONTROLES DEL TAMAO DE LA VENTANA PRINCIPAL 
*#########################################################################################################################

procedure VENTANA_NORMAL
          ventana_principal.WIDTH  := ancho_ventana
          ventana_principal.HEIGHT := largo_ventana
return

*************************************************************************************************
procedure VENTANA_EXPANDIDA
Local aux
          aux := ventana_principal.WIDTH  + ESPACIO_IMAGE * (MAX_NRO_COLUMNAS - 1)
          ventana_principal.WIDTH  := aux
     
          aux := ventana_principal.HEIGHT + ESPACIO_IMAGE * (MAX_NRO_FILAS - 1)
          ventana_principal.HEIGHT := aux
return

************************************************************************************************
procedure LARGO_ANCHO_VENTANA (largo, ancho)
Local area
          ventana_principal.setfocus
          area := AREA_VENTANA ()   // llamada a la funcion en C
          largo := area [1] / MAX_NRO_FILAS
          ancho := area [2] / MAX_NRO_COLUMNAS
return 


*#########################################################################################################################
*   FUNCIONES EN C        
*#########################################################################################################################

#pragma begindump

#include <shlobj.h>   
#include <winuser.h>
#include <windows.h>

#include "hbapi.h"

#include <stdlib.h>
#include <time.h>

//***************************************************************************************************
// OBTIENE EL TAMAO DEL AREA DEL CLIENTE DE LA VENTANA ACTIVA
//***************************************************************************************************
HB_FUNC (AREA_VENTANA)
{  
   HWND hWnd;
   RECT rectangulo;
   BOOL ret;
   
   hWnd = GetActiveWindow ();
   ret = GetClientRect(hWnd, &rectangulo);
   hb_reta( 2 );
   // rectangulo.top    siempre igual a 0 porque son coordenadas relativas
   // rectangulo.left   siempre igual a 0 porque son coordenadas relativas
   hb_storvnl( rectangulo.bottom, -1, 1 );
   hb_storvnl( rectangulo.right, -1, 2);
}

//**************************************************************************************************
// REPINTA EL AREA DEL CLIENTE DE LA VENTANA ACTIVA
//**************************************************************************************************
HB_FUNC (REPINTAR_VENTANA)
{
   HWND hWnd;
   BOOL ret;

   hWnd = GetActiveWindow ();
   ret = InvalidateRect(hWnd, NULL, FALSE);
   ret = UpdateWindow (hWnd);
   
   hb_retl(ret);
}

//****************************************************************************************************
// RETORNA UN NUMERO ALEATORIO ENTERO ENTRE 0 Y (num -1)
// num ES EL PARAMETRO PASADO A ESTA FUNCION
// Ejem. Nro_Aleatorio (100) ===> RETORNA UN NUMERO ALEATORIO ENTERO ENTRE 0 Y 99
//****************************************************************************************************

// Macros del Tubo C++
#define randomize()     srand((unsigned)time(NULL))
#define random(num)     (int)(((long)rand()*(num))/RAND_MAX)

HB_FUNC (NRO_ALEATORIO)
{  static int flag = 0;
  
   if (flag == 0)
    {  randomize ();
       flag = 1;       
    }
 
    if (hb_pcount()== 1 && hb_parinfo(1) == HB_IT_INTEGER)   
    {   hb_retni(random (hb_parni(1))); // retrieve a numeric parameter as a integer       
    }
    else
    {  hb_retni(-1);    // returns a integer number
    }  
}



//*********************************************************
// Cambia el texto del MENU
// SET_MENU_TXT (HandleWin, pos_Main_Menu, texto)
//*********************************************************

HB_FUNC (SET_MENU_TXT)
{
   HWND hWnd;
   HMENU hMenu;
   unsigned int pos, ID_item;
   char *p_texto;
   
   
    if (hb_pcount() != 3 || hb_parinfo(1) != HB_IT_INTEGER  || hb_parinfo(2) != HB_IT_INTEGER || hb_parinfo(3) != HB_IT_STRING)
    {   hb_retni(-1);
        return;
    }    
    
    hWnd    = (HWND) hb_parnl (1);
    pos     = hb_parni(2) -1;
    p_texto = hb_parcx (3);
    
  //  hWnd = GetActiveWindow ();
    
    hMenu = GetMenu(hWnd);
        
    if ((pos + 1) > GetMenuItemCount(hMenu))
    {   hb_retni(-2);
        return;
    }    
    
    ID_item = GetMenuItemID(hMenu,pos);   
    
    ModifyMenu(hMenu, pos, MF_BYPOSITION+MF_STRING, ID_item, p_texto);
    DrawMenuBar (hWnd);
    hb_retni(1);
}


//**********************************************************************************
// Cambia el texto de un SUBMENU
// SET_SUBMENU_TXT (HandleWin, pos_Main_Menu, pos_Sub_Menu, texto)
//**********************************************************************************

HB_FUNC (SET_SUBMENU_TXT)
{
   HWND hWnd;
   HMENU hMenu, hMenu_Sub;
   unsigned int pos1, pos2, ID_item, flag;
   char *p_texto = NULL;
   
   
    if (hb_pcount() != 4 || hb_parinfo(1) != HB_IT_INTEGER || hb_parinfo(2) != HB_IT_INTEGER || hb_parinfo(3) != HB_IT_INTEGER || hb_parinfo(4) != HB_IT_STRING)
    {   hb_retni(-1);
        return;
    }    
    
    hWnd    = (HWND) hb_parnl (1);
    pos1    = hb_parni(2) -1;
    pos2    = hb_parni(3) -1;
    p_texto = hb_parcx (4);
    
    //  hWnd = GetActiveWindow ();
    
    hMenu = GetMenu(hWnd);
    
    if ((pos1 + 1) > GetMenuItemCount(hMenu))
    {   hb_retni(-2);
        return;
    }
    
    hMenu_Sub = GetSubMenu(hMenu,pos1);
    
    if ((pos2 + 1) > GetMenuItemCount(hMenu_Sub))
    {   hb_retni(-3);
        return;
    }    
    
    ID_item = GetMenuItemID(hMenu_Sub, pos2);   
    
    flag = GetMenuState(hMenu_Sub, pos2, MF_BYPOSITION);
    
    ModifyMenu(hMenu_Sub, pos2, MF_BYPOSITION+MF_STRING+flag, ID_item, p_texto);
    DrawMenuBar (hWnd);
    hb_retni(1);
}

#pragma enddump


